// Smooth Moods Machine: Constants
// 4/12/12
// Gordon McComb

// Channel voice messages
#define   NOTE_OFF               0x80   // Data: key, velocity
#define   NOTE_ON                0x90   // Data: key, velocity
#define   CONTROLLER             0xB0   // Data: controller num, value

// Control change messages
#define   CTRL_BANK              0x00   // Select bank of instruments
#define   CTRL_VOLUME            0x07   // Set volume (0-127)
#define   CTRL_INSTRUMENT        0xC0   // Set instrument within bank
#define   CTRL_ALL_OFF           0x7B   // All notes off
#define   CTRL_EXPRESS           0x0B   // Expression 

// Instrument banks
#define   BANK_MELODIC           0x79   // "Melody" instruments
#define   BANK_PERCUSSION        0x78   // Percussion (drum) instruments

// Channels and chords
#define   NUM_CHANNELS           6
#define   CHIME                  4      // Channel for chimes
#define   SURF                   5      // Channel for surf 1
#define   THRUM                  6      // Channel for surf 2
#define   UI                     7      // UI feedback channel

// Instruments
#define   SURF_INSTRUMENT        122     // Instrument for surf effect
#define   CHORD_INSTRUMENT       88      // Instrument for major chords
  // Others to try: 90, 89, 97, 99, 103, 39, 49, 53, 64, 73
#define   THRUM_INSTRUMENT       82      // Instrument for thrum effect

// Chords
#define   CHORD_NOTES            3
#define   CROSS_FADE             20      // Cross-fade delay for chords

// Chimes
#define   CHIMEON_DELAY          100     // Randomizer delays
#define   CHIMEOFF_DELAY         3000
#define   CHIME_STEP             50
#define   CHIME_RANDOMIZER       70

// Surf
#define   SURF_DELAY             4000
#define   SURF_SURGE_MIN         0
#define   SURF_SURGE_MAX         70
#define   SURF_SUSTAIN_MIN       1000
#define   SURF_SUSTAIN_MAX       5500

//Thrum
#define   THRUM_LOW              33
#define   THRUM_HIGH             48

//Pink noise
#define   PINK_MIN               80
#define   PINK_SURGE_MIN         50
#define   PINK_SURGE_MAX         100

// Background timers
#define   BG_TIMER_INTERVAL      200000    // 200 ms
#define   RESET_FLAG_DELAY       50        // 50 ms (added to bgtimer delay)
#define   TIME_OUT_INTERVAL      1800000UL // Set shutoff time out (30 minutes)
                                 // Calculate as 6000 * minutes, or 0 for no shutoff

// EEPROM byte vectors
#define   PROM_MODE              0        // Mode

//Sony TV codes
#define   IR_POWER               0xA90
#define   IR_BUTTON_1            0x10
#define   IR_BUTTON_2            0x810
#define   IR_BUTTON_3            0x410
#define   IR_BUTTON_4            0xC10
#define   IR_BUTTON_5            0x210
#define   IR_BUTTON_6            0xA10
#define   IR_BUTTON_7            0x610
#define   IR_BUTTON_8            0xE10
#define   IR_BUTTON_9            0x110
#define   IR_BUTTON_0            0x910
#define   IR_VOL_UP              0x7B0
#define   IR_VOL_DOWN            0x3B0
#define   IR_CHANNEL_DOWN        0xAF0      
#define   IR_CHANNEL_UP          0x2F0
#define   IR_MUTE                0x290

// Pin assignments
#define   midiIn                 3       // MIDI input
#define   resetPin               4       // Reset
#define   IRSignalIn             8       // IR receiver signal in
#define   IRGround               9       // IR receiver ground (from LOW state)
#define   IRPower                10      // IR receiver power (from HIGH state)


